#include <QtGui>
#include <iostream>
#include <string>
#include <unistd.h>
#include <QString>
#include <QtCore/QTextCodec>
#include <sys/wait.h>
#include <signal.h>

#include "maindialog.h"

using namespace std;


MainDialog::MainDialog(QWidget *parent, string pawd)
	: QDialog(parent) , password(pawd)
{
	this->updateStatus = 0; //off
	setupUi(this);

	QTextCodec::setCodecForCStrings(QTextCodec::codecForLocale());
	QTextCodec::setCodecForTr(QTextCodec::codecForLocale());

	(void) signal(SIGUSR1, showFinishDialog);
};

void MainDialog::on_about_bt_clicked()
{
	//QTextCodec::setCodecForCStrings(QTextCodec::codecForLocale());
	//QTextCodec::setCodecForTr(QTextCodec::codecForLocale());

	QMessageBox::information(this, "关于","Ubuntu简易系统更新器\n\n版本：0.1.2\n作者：vincent\n意见与建议：vincent17113@gmail.com");
};

void MainDialog::on_quit_bt_clicked()
{
	//QTextCodec::setCodecForCStrings(QTextCodec::codecForLocale());
	//QTextCodec::setCodecForTr(QTextCodec::codecForLocale());
	if (MainDialog::updateStatus == 0)	this->close();
	else
	{
		QMessageBox::information(this, "信息提示","正在更新操作当中，不能退出程序！");
	}
}

void MainDialog::on_start_bt_clicked()
{
	//QTextCodec::setCodecForCStrings(QTextCodec::codecForLocale());
	//QTextCodec::setCodecForTr(QTextCodec::codecForLocale());

	if (MainDialog::updateStatus == 1) //on
	{
		/*
		if (waitpid(this->child_pid, 0, WNOHANG) != 0)
		{
			QMessageBox::information(this, "信息提示", "上一次操作已经完成，操作信息输出请查看终端！");
			this->updateStatus = 0;
			return ;
		}
		else
		{
			QMessageBox::information(this, "信息提示", "操作正在进行当中,操作信息输出请查看终端，此窗口可关闭！");
			return ;
		}
		*/
		QMessageBox::information(this, "信息提示", "操作正在进行当中,信息输出请查看终端，此窗口请关闭！当操作完成后会有提示信息窗口弹出进行提示！");
		return ;
	}

	int ret = QMessageBox::warning(this, "确定更新吗？", "确定更新所选择的更新源和更新操作吗？", QMessageBox::Yes | QMessageBox::No, QMessageBox::Yes);
	if (ret == QMessageBox::No) return ;

	string source_str = this->source_comboBox->currentText().toStdString();
	//if (source_str.compare("保持当前更新源") == 0) cout << "YES" << endl;
	if (source_str.compare("保持当前更新源") != 0)
	{
		int first_underline_pos = source_str.find('_');
		int second_underline_pos = source_str.find('_', first_underline_pos + 1);
		string file_str = source_str.substr(0, first_underline_pos);
		string folder_str = source_str.substr(first_underline_pos + 1, second_underline_pos - first_underline_pos - 1);
		//cout << file_str << " " << folder_str << endl;
		system(("echo " +  this->password + " | sudo -S cp ./sources/" + folder_str + "/"  + file_str + " /etc/apt/sources.list").c_str());
	}

	string chosen_str = "";
	if (clean_checkBox->isChecked()) chosen_str += "1"; 	else chosen_str += "0";
	if (autoclean_checkBox->isChecked()) chosen_str += "1"; 	else chosen_str += "0";
	if (autoremove_checkBox->isChecked()) chosen_str += "1";	else chosen_str += "0";
	if (update_checkBox->isChecked()) chosen_str += "1";	else chosen_str += "0";
	if (upgrade_checkBox->isChecked()) chosen_str += "1";	else chosen_str += "0";
	if (none_radioButton->isChecked()) chosen_str += "1";	else chosen_str += "0";
	if (reboot_radioButton->isChecked()) chosen_str += "1";	else chosen_str += "0";
	if (shutdown_radioButton->isChecked()) chosen_str += "1";	else chosen_str += "0";
	//cout << "chosen_str=" << chosen_str << endl;

	char *argv_execv[4];
	argv_execv[0] = "system_update";
	argv_execv[1] = const_cast<char *>(chosen_str.c_str());
	argv_execv[2] = const_cast<char *>(this->password.c_str());
	argv_execv[3] = NULL;


	MainDialog::child_pid = fork();
	if (MainDialog::child_pid == 0)
	{
		//cout << "child" << endl;
		if (execv("./updateCpp/system_update", argv_execv) < 0)
			perror("Err on execv");
	}
	else  if (MainDialog::child_pid < 0)
		cout << "fork error" << endl;

	MainDialog::updateStatus = 1;

	QMessageBox::information(this, "信息提示", "操作正在进行当中,信息输出请查看终端，此窗口请关闭！当操作完成后会有提示信息窗口弹出进行提示！");
};

/*
static void MainDialog::showFinishDialog(int sig)
{
	QMessageBox::information(NULL, "信息提示", "操作已经完成！");
}
*/

