#ifndef MAINDIALOG_H
#define MAINDIALOG_H

#include <QDialog>
#include <QMessageBox>
#include <string>
#include <unistd.h>
#include <signal.h>
#include <sys/wait.h>

#include "ui_maindialog.h"

using namespace std;

class MainDialog : public QDialog, public Ui::MainDialog
{
	Q_OBJECT

public:
	MainDialog(QWidget *parent = 0, string password = "NULL");

private slots:
	void on_about_bt_clicked();
	void on_start_bt_clicked();
	void on_quit_bt_clicked();

private:
	string password;

	static pid_t child_pid;

	static int updateStatus;	//0 : off      1 : on

	static void showFinishDialog(int sig)
	{
		sleep(3);
		waitpid(MainDialog::child_pid, 0, WNOHANG);
		QMessageBox::information(NULL, "信息提示", "操作已经完成！");
		MainDialog::updateStatus = 0; //off
	}
};

#endif // MAINDIALOG_H
